var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { IsArray, IsBoolean, IsOptional, IsString } from 'class-validator';
import { JSONSchema } from 'class-validator-jsonschema';
import { QueryDoc } from '@easylayer/common/shared-interfaces';
export class FetchEventsQueryDto {
}
__decorate([
    IsArray(),
    IsString({ each: true }),
    JSONSchema({ description: 'Array of model IDs to fetch events for', example: ['mempool-1', 'network-1'] }),
    __metadata("design:type", Array)
], FetchEventsQueryDto.prototype, "modelIds", void 0);
__decorate([
    IsOptional(),
    JSONSchema({ description: 'Filter criteria for events', example: { blockHeight: 19000000 } }),
    __metadata("design:type", Object)
], FetchEventsQueryDto.prototype, "filter", void 0);
__decorate([
    IsOptional(),
    JSONSchema({ description: 'Pagination settings for event retrieval', example: { limit: 10, offset: 0 } }),
    __metadata("design:type", Function)
], FetchEventsQueryDto.prototype, "paging", void 0);
__decorate([
    IsOptional(),
    IsBoolean(),
    JSONSchema({ description: 'Enable streaming response for large event datasets', default: false, example: true }),
    __metadata("design:type", Boolean)
], FetchEventsQueryDto.prototype, "streaming", void 0);
let FetchEventsQuery = class FetchEventsQuery {
    constructor(payload) {
        this.payload = payload;
    }
};
FetchEventsQuery = __decorate([
    QueryDoc({
        description: 'Retrieves EVM events for one or more models with pagination and filtering options',
        category: 'Core',
        streaming: true,
    }),
    __metadata("design:paramtypes", [Object])
], FetchEventsQuery);
export { FetchEventsQuery };
